drm/bridge: adv7511: Switch to atomic operations
[drm/drm-misc.git] / tools / testing / selftests / net / test_vxlan_under_vrf.sh
blobae8fbe3f0779b7cfa5745afde2ba9f1114dfab74
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
4 # This test is for checking VXLAN underlay in a non-default VRF.
6 # It simulates two hypervisors running a VM each using four network namespaces:
7 # two for the HVs, two for the VMs.
8 # A small VXLAN tunnel is made between the two hypervisors to have the two vms
9 # in the same virtual L2:
11 # +-------------------+ +-------------------+
12 # | | | |
13 # | vm-1 netns | | vm-2 netns |
14 # | | | |
15 # | +-------------+ | | +-------------+ |
16 # | | veth-hv | | | | veth-hv | |
17 # | | 10.0.0.1/24 | | | | 10.0.0.2/24 | |
18 # | +-------------+ | | +-------------+ |
19 # | . | | . |
20 # +-------------------+ +-------------------+
21 # . .
22 # . .
23 # . .
24 # +-----------------------------------+ +------------------------------------+
25 # | . | | . |
26 # | +----------+ | | +----------+ |
27 # | | veth-tap | | | | veth-tap | |
28 # | +----+-----+ | | +----+-----+ |
29 # | | | | | |
30 # | +--+--+ +--------------+ | | +--------------+ +--+--+ |
31 # | | br0 | | vrf-underlay | | | | vrf-underlay | | br0 | |
32 # | +--+--+ +-------+------+ | | +------+-------+ +--+--+ |
33 # | | | | | | | |
34 # | +---+----+ +-------+-------+ | | +-------+-------+ +---+----+ |
35 # | | vxlan0 |....| veth0 |.|...|.| veth0 |....| vxlan0 | |
36 # | +--------+ | 172.16.0.1/24 | | | | 172.16.0.2/24 | +--------+ |
37 # | +---------------+ | | +---------------+ |
38 # | | | |
39 # | hv-1 netns | | hv-2 netns |
40 # | | | |
41 # +-----------------------------------+ +------------------------------------+
43 # This tests both the connectivity between vm-1 and vm-2, and that the underlay
44 # can be moved in and out of the vrf by unsetting and setting veth0's master.
46 source lib.sh
47 set -e
49 cleanup() {
50 ip link del veth-hv-1 2>/dev/null || true
51 ip link del veth-tap 2>/dev/null || true
53 cleanup_ns $hv_1 $hv_2 $vm_1 $vm_2
56 # Clean start
57 cleanup &> /dev/null
59 [[ $1 == "clean" ]] && exit 0
61 trap cleanup EXIT
62 setup_ns hv_1 hv_2 vm_1 vm_2
63 hv[1]=$hv_1
64 hv[2]=$hv_2
65 vm[1]=$vm_1
66 vm[2]=$vm_2
68 # Setup "Hypervisors" simulated with netns
69 ip link add veth-hv-1 type veth peer name veth-hv-2
70 setup-hv-networking() {
71 id=$1
73 ip link set veth-hv-$id netns ${hv[$id]}
74 ip -netns ${hv[$id]} link set veth-hv-$id name veth0
76 ip -netns ${hv[$id]} link add vrf-underlay type vrf table 1
77 ip -netns ${hv[$id]} link set vrf-underlay up
78 ip -netns ${hv[$id]} addr add 172.16.0.$id/24 dev veth0
79 ip -netns ${hv[$id]} link set veth0 up
81 ip -netns ${hv[$id]} link add br0 type bridge
82 ip -netns ${hv[$id]} link set br0 up
84 ip -netns ${hv[$id]} link add vxlan0 type vxlan id 10 local 172.16.0.$id dev veth0 dstport 4789
85 ip -netns ${hv[$id]} link set vxlan0 master br0
86 ip -netns ${hv[$id]} link set vxlan0 up
88 setup-hv-networking 1
89 setup-hv-networking 2
91 # Check connectivity between HVs by pinging hv-2 from hv-1
92 echo -n "Checking HV connectivity "
93 ip netns exec $hv_1 ping -c 1 -W 1 172.16.0.2 &> /dev/null || (echo "[FAIL]"; false)
94 echo "[ OK ]"
96 # Setups a "VM" simulated by a netns an a veth pair
97 setup-vm() {
98 id=$1
100 ip link add veth-tap type veth peer name veth-hv
102 ip link set veth-tap netns ${hv[$id]}
103 ip -netns ${hv[$id]} link set veth-tap master br0
104 ip -netns ${hv[$id]} link set veth-tap up
106 ip link set veth-hv address 02:1d:8d:dd:0c:6$id
108 ip link set veth-hv netns ${vm[$id]}
109 ip -netns ${vm[$id]} addr add 10.0.0.$id/24 dev veth-hv
110 ip -netns ${vm[$id]} link set veth-hv up
112 setup-vm 1
113 setup-vm 2
115 # Setup VTEP routes to make ARP work
116 bridge -netns $hv_1 fdb add 00:00:00:00:00:00 dev vxlan0 dst 172.16.0.2 self permanent
117 bridge -netns $hv_2 fdb add 00:00:00:00:00:00 dev vxlan0 dst 172.16.0.1 self permanent
119 echo -n "Check VM connectivity through VXLAN (underlay in the default VRF) "
120 ip netns exec $vm_1 ping -c 1 -W 1 10.0.0.2 &> /dev/null || (echo "[FAIL]"; false)
121 echo "[ OK ]"
123 # Move the underlay to a non-default VRF
124 ip -netns $hv_1 link set veth0 vrf vrf-underlay
125 ip -netns $hv_1 link set vxlan0 down
126 ip -netns $hv_1 link set vxlan0 up
127 ip -netns $hv_2 link set veth0 vrf vrf-underlay
128 ip -netns $hv_2 link set vxlan0 down
129 ip -netns $hv_2 link set vxlan0 up
131 echo -n "Check VM connectivity through VXLAN (underlay in a VRF) "
132 ip netns exec $vm_1 ping -c 1 -W 1 10.0.0.2 &> /dev/null || (echo "[FAIL]"; false)
133 echo "[ OK ]"